//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "RGrids.hpp"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
//---------------------------------------------------------------------------
// 
enum SD
     {
       ssdNone,
       ssdUp,
       ssdDn,
     };     

//     Data 
typedef struct {
                 AnsiString CellText;
               } TCellText;   

//     Data 
typedef struct {
                 int RowIndex;
               } TRowData;       

//     Data 
typedef struct {
                 int ColIndex;
               } TColData;                                
     
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *StatusBar1;
        TRGrid *RGrid1;
        TImageList *ImageList1;
        void __fastcall RGrid1FreeCell(TRCustomGrid *Sender, TRCell *Cell);
        void __fastcall RGrid1DrawCellText(TRCustomGrid *Sender,
          TRCell *Cell, int ACol, int ARow, TRGridDrawStates State,
          TRect &Rect, AnsiString &CellText, bool &Multiline,
          TAlignment &HorAlignment, TRVertAlignment &VertAlignment);
        void __fastcall RGrid1DrawImage(TRCustomGrid *Sender, TRCell *Cell,
          int ACol, int ARow, TRGridDrawStates State, TRect &Rect,
          int &ImageIndex, TAlignment &HorAlignment,
          TRVertAlignment &VertAlignment);
        void __fastcall RGrid1FreeCellsVector(TRCustomGrid *Sender,
          TRCellsVector *CellsVector);
        void __fastcall RGrid1CheckButton(TRCustomGrid *Sender,
          TRCell *Cell, int ACol, int ARow, bool &Enabled);
        void __fastcall RGrid1FixedCellClick(TRCustomGrid *Sender,
          TRCell *Cell, int ACol, int ARow);
        void __fastcall RGrid1MarkRow(TRCustomGrid *Sender,
          TRCellsVector *CellsVector, bool MarkValue, bool &CanMark);
        void __fastcall RGrid1FocusCell(TRCustomGrid *Sender, TRCell *Cell,
          int &ACol, int &ARow);
private:	// User declarations
        SD SortDirection;

        int __fastcall ShowMessageBox(const AnsiString Text, const AnsiString Caption, int Flags);
        void __fastcall UpdateSatusBar(int ACol, int ARow);

public:		// User declarations
       int SortColumn; 
       
        __fastcall TForm1(TComponent* Owner);
};   
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------   
int __fastcall CompareRowsUp(void * Item1, void * Item2);
int __fastcall CompareRowsDn(void * Item1, void * Item2);
//---------------------------------------------------------------------------
#endif
